=== debian/changelog ===
uhd (3.5.5-1) unstable; urgency=low

  * New upstream release
    Nicholas Corgan:
      uhd_images_downloader: fixes/improvements, redundancy fixes,
        better error handling, more descriptive error when MD5 check fails
      lib: dbsrx2 bugfix

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 20 Nov 2013 21:48:35 -0500

uhd (3.5.4-4) unstable; urgency=low

  * update to git 6bb62ea (head of maint branch) to fix BUG #203
  Michael Dickens (1):
        utils: fix declaration of "env_path_sep" such that it is always
        initialized before it is used in the "get_env_paths" function, by
        moving it from the global scope to inside that function.  This
        change allows UHD_STATIC_BLOCK(load_modules) to work correctly.
  
  Michael West (1):
        BUG #203:  Initialized gain values to 0.0
  
  Nicholas Corgan (3):
        cmake: fixed UHD_IMAGES_DIR behavior to include directories
               inside specified images directory
        Updated images downloader URL
        docs: added info on libusbx for Windows
  
 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 13 Nov 2013 19:20:05 -0500

uhd (3.5.4-3) unstable; urgency=low

  * Fix syntax to avoid failing test on powerpc

 -- A. Maitland Bottoms <bottoms@debian.org>  Tue, 29 Oct 2013 09:30:06 -0400

uhd (3.5.4-2) unstable; urgency=low

  * Avoid failing test on powerpc
  * Add pkg-config dependency to help find liborc

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 28 Oct 2013 21:07:40 -0400

uhd (3.5.4-1) unstable; urgency=low

  * New upstream release

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 27 Sep 2013 23:43:51 -0400

uhd (3.5.3-1) unstable; urgency=low

  * New upstream release
      UHD source includes man pages now
      Moved usrp_n2xx_simple_net_burner and usrp2_card_burner into bin
  * Add watchfile (Closes: #702937)
  * Add USRP B100 2500:0002 to udev rules (Closes: #705509)
  * No more uhd_install_firmware, use uhd_images_downloader (Closes: #654637)

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 26 May 2013 22:41:47 -0400

uhd (3.5.2-1) experimental; urgency=low

  * New upstream release
      B100:
          Fix get send buffer timeout
      E1x0:
          Changes to bus timings for S issue
      USRP1:
          Restore broken EEPROM writing
  * Plus fixes
      E110:
          Fix FPGA Makefile build typo
      UHD:
          Fixed timespec irrational rate rounding
          Multichan streamer CPU utilization

 -- A. Maitland Bottoms <bottoms@debian.org>  Mon, 22 Apr 2013 22:30:53 -0400

uhd (3.5.1-1) experimental; urgency=low

  * New upstream release
    Misc:
      Fixes to images downloader
      Fixes to C++ net burner
      Added sleep(1) to query_gpsdo_sensors
    OSX:
      Fix for socket send code newer OS versions
  * Upload to experimental during wheezy freeze

 -- A. Maitland Bottoms <bottoms@debian.org>  Sun, 27 Jan 2013 23:33:25 -0500

uhd (3.5.0-1) experimental; urgency=low

  * New upstream release
      B100:
          Added timed commands feature
          Incremented FPGA compat number to 11.1
          Incremented firmware compat number to 3
      E1x0:
          Added timed commands feature
          Incremented FPGA compat number to 11.1
      USRP2/N2x0:
          Alternative stream destination on TX
          Incremented FPGA compat number to 10
      N2x0:
          Implemented timed-commands feature
          Implemented fast-commands feature
      SBX/WBX
          Tune with phase sync using timed-commands
      RFX series
          Added calibration utilities support
      General:
          SSE2 conversions for sc8 RX samples
          Added multi-threading to packet converters
          Added automatic images fetcher application

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 09 Jan 2013 14:24:11 -0500

uhd (3.4.4-1) experimental; urgency=low

  * New upstream release
    * Gen2
        Fix RX and TX DSP scalar adjustments
    * B100/E1x0
        Fixed RX ADC IQ inversion swap
        Incremented FPGA compat number to 9.4

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 18 Oct 2012 13:21:54 -0400

uhd (3.4.3-1) experimental; urgency=low

  * New upstream release
    XCVR2450:
        Fix to disable automatic LO offset on TX
    N2x0:
        Deal with misc exceptions in net burner
    E1x0:
        Changes to add reliability to bus state machine
    USRP1:
        Shutoff the DAC on transmit EOB flags
        Revert 1st nyquist zone DAC calculation

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 05 Sep 2012 21:55:04 -0400
